package eu.eudat.models.data.dmp;

import eu.eudat.models.DataModel;
import eu.eudat.logic.utilities.helpers.LabelGenerator;

import java.util.Date;

public class Organisation implements DataModel<eu.eudat.data.entities.Organisation, Organisation>, LabelGenerator {
    private String label;
    private String name;
    private String id;
    private int status;
    private String tag;

    public String getLabel() {
        return label;
    }
    public void setLabel(String label) {
        this.label = label;
    }

    public String getName() {
        return name;
    }
    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
        return id;
    }
    public void setId(String id) {
        this.id = id;
    }

    public int getStatus() {
        return status;
    }
    public void setStatus(int status) {
        this.status = status;
    }

    public String getTag() {
        return tag;
    }
    public void setTag(String tag) {
        this.tag = tag;
    }

    @Override
    public Organisation fromDataModel(eu.eudat.data.entities.Organisation entity) {
        this.id = entity.getReference();
        this.name = entity.getLabel();
        this.label = entity.getUri();
        if (entity.getReference().contains(":cristin")) {
            this.tag = "cristin";
        } else {
            this.tag = entity.getReference().substring(0, entity.getReference().indexOf(":"));
        }
        return this;
    }

    @Override
    public eu.eudat.data.entities.Organisation toDataModel() {
        eu.eudat.data.entities.Organisation organisationEntity = new eu.eudat.data.entities.Organisation();
        if (this.tag.equals(this.id.substring(0, this.tag.length()))) {
            organisationEntity.setReference(this.id);
        } else {
            organisationEntity.setReference(this.tag + ":" + this.id);
        }
        organisationEntity.setLabel(this.name);
        organisationEntity.setUri(this.label);
        organisationEntity.setCreated(new Date());
        organisationEntity.setStatus((short) this.status);
        return organisationEntity;
    }

    @Override
    public String generateLabel() {
        return this.getName();
    }

    @Override
    public String getHint() {
        return null;
    }
}
